'' =================================================================================================
''
''   File....... jm_etimer_demo.spin
''   Purpose.... Background timer
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2009 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.com
''   Started.... 21 JUL 2009
''   Updated.... 22 JUL 2009
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
  
con

  #0, CLS, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR           ' PST formmatting control  
  

obj

  term : "jm_txserial"
  et   : "jm_etimer"


var

  long  mytimer[5]
  

pub main 

  term.init(30, 115_200)
  waitcnt(clkfreq / 10 + cnt)
  term.tx(CLS)

  et.init(0)                                                    ' 1Hz heartbeat on P0

  repeat
    term.tx(HOME)
    et.read(@mytimer)

    dec2(mytimer[3])
    term.tx(":")
    dec2(mytimer[2])
    term.tx(":")
    dec2(mytimer[1])
    term.tx(".")
    dec3(mytimer[0])

    waitcnt(clkfreq / 1000 + cnt) 


pub dec2(n)

  if (n < 10)
    term.tx("0")
    
  term.dec(n)


pub dec3(n)

  if (n < 10)
    term.tx("0")

  if (n < 100)
    term.tx("0")
    
  term.dec(n)

